<template>
  <div
    class="select"
    :class="{
      'select--is-focused': isFocused,
    }"
    :tabindex="0"
    @focus="focus"
  >
    <select
      ref="input"
      v-model="val"
      class="select__select"
      :class="{
        'select__select--placeholder': !val && !!placeholder
      }"
      @focus="focus"
      @blur="blur"
    >
      <option
        v-for="{key, text} in computedOptions"
        :key="key"
        :value="key"
        :disabled="!key"
      >
        {{ text }}
      </option>
    </select>
    <slot name="after">
      <Icon
        slot="after"
        type="angleDown"
      />
    </slot>
  </div>
</template>

<script>
import Icon from '../../Icon';
import formElementMixin from '../formElementMixin';

export default {
  name: 'FormSelect',
  components: { Icon },
  mixins: [formElementMixin],
  props: {
    options: Array,
  },
  computed: {
    computedOptions() {
      return [
        ...(this.placeholder ? [{ key: null, text: this.placeholder }] : []),
        ...this.options,
      ];
    },
  },
};
</script>

<style lang="scss">
  @import "../formElementMixin";

  .select {
    @include container;

    &__select {
      @include input;

      &--placeholder {
        @include placeholder;
      }
    }
  }
</style>
